#if !defined(_DWD_H)
#define _DWD_H

#include <WiFiClient.h>
#include <HTTPClient.h>
class DWDClient
{
public:
  WiFiClient *_client;
  String currentMessage;

  explicit DWDClient(WiFiClient *client);
  void begin(int intervalMinutes, String region);
  void check();
  void loop();
  bool isDirty();

private:
  bool _dirty;
  unsigned long lastCheck = 0;
  unsigned long checkInterval = 300000;
  String lastMessage;
  String rssUrl;
  String rssData;
  HTTPClient _http;
  String parseRSS(String xmlData);
  String extractTagContent(String source, String tag);
};
#endif