#if !defined(_MAIN_H)
#define _MAIN_H
#define PIN_LED 25

#include <AsyncTCP.h>
#include <ESPAsyncWebServer.h>
#include <WiFi.h>
#include <ezTime.h>
#include <webserver.h>
#include <DNSServer.h>

#include <PubSubClient.h>
#include <RadioLib.h>

#ifdef DEBUG
  #define dbg(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define err(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define info(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define warn(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
#else
  #define dbg(format, arg...) do {} while (0)
  #define err(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define info(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define warn(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
#endif

#define RADIOLIB_LOW_LEVEL 1
#define RADIOLIB_GODMODE 1
//
// #define POCSAG_DEBUG 1
// #define POCSAG_DEBUG_PORT Serial
#include <pocsag_transmitter.h>
#include <board.h>
#include <config.h>
#include <dwd.h>
#include <mowas.h>
#include <display.h>

void txControllerBatchClear();
void txControllerBatchStart();
int txControllerBatchQueueCount();
String txHandleUmlauts(String message);
void txControllerInsert(uint32_t ric, uint8_t functionBit, char *text);
void setup_radio();
void setup_network();
void setup_mqtt();
void setup_broadcasts();
void setup_leds();
//
void mqtt_callback(char* topic, byte* payload, unsigned int length);
//
void broadcast_loop();
void broadcastTriggerTimeBeacon();
void heap_loop();
#endif