#if !defined(_MOWAS_H)
#define _MOWAS_H

#include <WiFiClient.h>
#include <HTTPClient.h>
#include <ArduinoJson.h>
class MoWaSClient
{
public:
    WiFiClient *_client;
    String currentMessage;

    explicit MoWaSClient(WiFiClient *client);
    void begin(int intervalMinutes, String region);
    bool check();
    void loop();
    bool isDirty();

private:
    bool _dirty;
    unsigned long lastCheck = 0;
    unsigned long checkInterval = 300000;
    String lastMessage;
    
    String dashboardData;
    String dashboardUrl;
    String warningUrl;

    HTTPClient _http;
    String parseDashboard(String jsonData);
    String extractTagContent(String source, String tag);
};
#endif